--	LÖVE Code Doodle #11
--		by HugoBDesigner

--	I didn't add any code to make the equator parts larger than the poles,
--	so that's why it looks "pointy". Although it would be too hard to make
--	it this way, so I'm not doing it...

function love.load()
	local files = love.filesystem.enumerate("maps")
	maps = {}
	for i, v in pairs(files) do
		local f = "maps/" .. v
		if love.filesystem.isFile(f) then
			local ext = string.sub(f, -4, -1)
			if ext == ".png" or ext == ".jpg" then
				table.insert(maps, love.graphics.newImage(f))
			end
		end
	end
	map = 1
	
	posx = 0
	rotspeed = 1
	
	love.graphics.setLineWidth(5)
end

function love.update(dt)
	if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
		posx = posx-dt*rotspeed
		if posx < 0 then
			posx = posx + 1
		end
	elseif love.keyboard.isDown("d") or love.keyboard.isDown("right") then
		posx = posx+dt*rotspeed
		if posx >= 1 then
			posx = posx - 1
		end
	end
end

function love.draw()
	love.graphics.setColor(255, 255, 255, 255)
	
	local radius = math.floor(maps[map]:getHeight()/2)
	
	local forlimit = 1
	if posx+radius > maps[map]:getWidth()/2 then
		forlimit = 2
	end
	
	local function myStencil()
		love.graphics.circle("fill", 400, 300, radius, 32)
	end
	love.graphics.setStencil(myStencil)
	
	for i = 1, radius*2 do
		local an = (i-1)/(radius*2)*math.pi
		local w = (math.sin(an)*2-1)*(maps[map]:getWidth()/2)
		local extrax = (math.sin(an)*2-1)*radius
		local newy = 300 - radius
		local sc = (maps[map]:getWidth()/2+w)/(maps[map]:getWidth())
		
		local wid = maps[map]:getWidth()*sc
		local newx = 400 - wid/2 - posx*wid
		while newx+wid < 400 - wid/2 do
			newx = newx + wid
		end
		
		love.graphics.setScissor(400-radius, newy+(i-1), radius*2, 2)
		while newx+wid < 400+wid/2+wid do
			love.graphics.draw(maps[map], newx, newy, 0, sc, 1)
			newx = newx+wid
		end
		
		love.graphics.setScissor()
	end
	
	love.graphics.setStencil()
end

function love.keypressed(key, unicode)
	if key == "w" or key == "up" then
		map = map - 1
		if map < 1 then
			map = #maps
		end
		posx = 0
	elseif key == "s" or key == "down" or key == " " or key == "enter" or key == "return" or key == "kpenter" then
		map = map + 1
		if map > #maps then
			map = 1
		end
		posx = 0
	elseif key == "escape" then
		love.event.quit()
	end
end